#include <iostream>
#include <memory>

class MyClass {
public:
    MyClass() { std::cout << "MyClass Constructor" << std::endl; }
    ~MyClass() { std::cout << "MyClass Destructor" << std::endl; }
};

int main() {
    std::shared_ptr<MyClass> ptr1 = std::make_shared<MyClass>();
    std::shared_ptr<MyClass> ptr2 = ptr1;  // Copy ptr1, reference count increases

    std::cout << "Reference count after copying: " << ptr1.use_count() << std::endl;  // Outputs: 2

    std::shared_ptr<MyClass> ptr3;
    ptr3 = ptr1;  // Assign ptr1 to ptr3, reference count remains the same

    std::cout << "Reference count after assignment: " << ptr1.use_count() << std::endl;  // Outputs: 3

    return 0;
}

